<?php

/**
 * Class DM_DigiMember_Integration
 */
class DM_DigiMember_Integration extends TVA_Integration
{
    protected function init_items()
    {
        $items = [];
        $all_products = digimember_listProducts();

        if (!empty($all_products) && is_array($all_products)) {
            foreach ($all_products as $product) {

                try {
                    $id = $product->id;
                    $item = new DM_DigiMember_Integration_Item($id, $product->name);
                    $items[] = $item;
                } catch (Exception $e) {
                }
            }
        }
        $this->set_items($items);
    }

    protected function _get_item_from_membership($key, $value)
    {
        try {
            $product = digimember_getProduct($value);
            return new DM_DigiMember_Integration_Item($product['id'], $product['name']);
        } catch (Exception $e) {
            return null;
        }
    }

    /**
     * Checks if current logged in user has a memberpress membership
     *
     * @param array $rule
     *
     * @return bool
     */
    public function is_rule_applied($rule)
    {
        $applied = false;
        $accessibleProducts = array_map(function ($id) {
            return $id;
        }, array_column(digimember_listAccessableProducts(), 'id'));

        foreach ($rule['items'] as $item) {
            $applied = in_array($item['id'], $accessibleProducts);
            if ($applied) {
                break;
            }
        }

        return $applied;
    }

    public function trigger_no_access()
    {
        // Do nothing and let login form be displayed
    }

    public function get_customer_access_items( $customer ) {
        return array();
    }

}